<template>
    <div>
        <ihm-tools
            v-if="isTools"
            @first="onChange(0)"
            @back="onBack"
            @next="onNext"
            @last="onChange(dataObject.length - 1)"
        ></ihm-tools>
        <div class="ihm-form">
            <div class="ihm">
                <header class="main-header">
                    <div class="row">
                        <div class="col-md-12">
                            <ul v-show="isNavigator" class="steps-display">
                                <li
                                    :class="{ active: dataStep == indexStep }"
                                    v-for="(step, indexStep) in dataObject"
                                    :key="indexStep"
                                >
                                    <span>{{ indexStep + 1 }}</span>
                                </li>
                            </ul>
                            <h2>
                                {{ getField("title") }}
                            </h2>
                            <h3>
                                {{ getField("subtitle") }}
                            </h3>
                        </div>
                    </div>
                </header>

                <transition-group
                    appear
                    name="fade"
                    class="form-steps ready"
                    tag="ul"
                >
                    <li
                        v-show="dataStep == indexStep"
                        v-for="(step, indexStep) in dataObject"
                        :key="indexStep"
                    >
                        <ihm-input
                            v-for="(input, indexInput) in step.inputs"
                            :key="indexInput"
                            :value="input"
                            @submit="onSubmit"
                        ></ihm-input>
                        <div v-show="isNavigator" class="row">
                            <div class="col-md-12 text-center">
                                <button @click="onBack" class="btn btn-back">
                                    Go Back
                                </button>
                            </div>
                        </div>
                    </li>
                </transition-group>
            </div>
        </div>
    </div>
</template>
<script>
import IhmTools from "./IhmToolsComponent";
import IhmInput from "./IhmInputComponent";
export default {
    components: {
        IhmTools,
        IhmInput
    },
    data() {
        return {
            dataLeadId: "",
            dataStep: 0,
            dataObject: {},
            isSubmit: false,
            isTools: false,
            show: true
        };
    },
    created() {
        this.prepare();
    },
    methods: {
        prepare() {
            if (localStorage.getItem("LeadId")) {
                this.dataLeadId = localStorage.getItem("LeadId");
            } else {
                this.dataLeadId = this.uuidv4();
                localStorage.setItem("LeadId", this.dataLeadId);
            }

            if (this.$route.query.tools) {
                this.isTools = true;
            }
            this.getObject(1);
        },
        getObject(id) {
            axios
                .get(`api/form/${id}`)
                .then(res => {
                    this.dataObject = res.data;
                    if (localStorage.getItem("step")) {
                        this.onChange(parseInt(localStorage.getItem("step")));
                    } else {
                        this.onChange(0);
                    }
                })
                .catch(err => {
                    console.warn(err.message);
                });
        },
        onNext() {
            this.onChange(this.dataStep + 1);
        },
        onBack() {
            this.onChange(this.dataStep - 1);
        },
        onChange(step) {
            if (step >= 0 && step < this.dataObject.length) {
                this.dataStep = step;
                localStorage.setItem("step", step);
                return step;
            }

            return false;
        },
        onSubmit() {
            if (this.validate()) {
                this.isSubmit = true;

                axios
                    .post("api/form", {
                        leadId: this.dataLeadId,
                        leadData: this.dataObject[this.dataStep]
                    })
                    .then(res => {
                        this.onNext();
                    })
                    .catch(err => {
                        console.warn(err.response.data.errors);
                    })
                    .then(res => {
                        this.isSubmit = false;
                    });
            }
        },
        getField(name) {
            return (
                this.dataObject[this.dataStep] &&
                this.dataObject[this.dataStep][name]
            );
        },
        validate() {
            var isValidate = true;

            this.dataObject[this.dataStep].inputs.forEach(input => {
                if (input.required) {
                    var Regex = new RegExp(input.pattern);

                    if (!input.value || !Regex.test(input.value)) {
                        input.invalid = true;
                        isValidate = false;
                    } else {
                        input.invalid = false;
                    }
                    // console.log(Regex.test(input.value));
                }
            });
            return isValidate;
        },
        uuidv4() {
            return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(
                /[xy]/g,
                function(c) {
                    var r = (Math.random() * 16) | 0,
                        v = c == "x" ? r : (r & 0x3) | 0x8;
                    return v.toString(16);
                }
            );
        }
    },
    computed: {
        isNavigator() {
            return (
                this.dataStep > 0 && this.dataStep < this.dataObject.length - 1
            );
        }
    }
};
</script>
<style scoped>
.fade-enter-active {
    transition: opacity 0.3s linear;
    transition-delay: 0.3s;
    
        
}
.fade-enter,
.fade-leave-to {
    opacity: 0;
}

.fade-leave-active {
    display: none;
    
}
</style>
